import{s as oe,o as ie,n as se}from"../chunks/scheduler.85c25b89.js";import{S as ce,i as me,g as f,s as o,r as g,A as de,h as u,f as a,c as i,j as N,u as h,x as K,k as F,y as T,a as l,v as $,d as b,t as k,w as _}from"../chunks/index.c142fe32.js";import{D as ae}from"../chunks/Docstring.e6639b56.js";import{C as pe}from"../chunks/CodeBlock.a5e95a57.js";import{E as fe}from"../chunks/ExampleCodeBlock.59b8d777.js";import{H as X,E as ge}from"../chunks/EditOnGithub.a592e7aa.js";function ue(H){let r,R="Usage:",p,c,m;return c=new pe({props:{code:"dHJhaW5lciUyMCUzRCUyMERQT1RyYWluZXIoLi4uKSUwQWp1ZGdlJTIwJTNEJTIwUGFpclJNSnVkZ2UoKSUwQXdpbl9yYXRlX2NhbGxiYWNrJTIwJTNEJTIwV2luUmF0ZUNhbGxiYWNrKGp1ZGdlJTNEanVkZ2UlMkMlMjB0cmFpbmVyJTNEdHJhaW5lciklMEF0cmFpbmVyLmFkZF9jYWxsYmFjayh3aW5fcmF0ZV9jYWxsYmFjayk=",highlighted:`trainer = DPOTrainer(...)
judge = PairRMJudge()
win_rate_callback = WinRateCallback(judge=judge, trainer=trainer)
trainer.add_callback(win_rate_callback)`,wrap:!1}}),{c(){r=f("p"),r.textContent=R,p=o(),g(c.$$.fragment)},l(n){r=u(n,"P",{"data-svelte-h":!0}),K(r)!=="svelte-5wyjqd"&&(r.textContent=R),p=i(n),h(c.$$.fragment,n)},m(n,d){l(n,r,d),l(n,p,d),$(c,n,d),m=!0},p:se,i(n){m||(b(c.$$.fragment,n),m=!0)},o(n){k(c.$$.fragment,n),m=!1},d(n){n&&(a(r),a(p)),_(c,n)}}}function he(H){let r,R,p,c,m,n,d,V,x,y,D,M,G,C,W,Q,J,ne="A <code>TrainerCallback</code> that displays the progress of training or evaluation using Rich.",Y,P,Z,s,j,z,U,re='A <a href="https://huggingface.co/docs/transformers/main/en/main_classes/callback#transformers.TrainerCallback" rel="nofollow">TrainerCallback</a> that computes the win rate of a model based on a reference.',ee,L,le=`It generates completions using prompts from the evaluation dataset and compares the trained model’s outputs against
a reference. The reference is either the initial version of the model (before training) or the reference model, if
available in the trainer. During each evaluation step, a judge determines how often the trained model’s completions
win against the reference using a judge. The win rate is then logged in the trainer’s logs under the key
<code>&quot;eval_win_rate&quot;</code>.`,te,v,q,E,B,S,A;return m=new X({props:{title:"Callbacks",local:"callbacks",headingTag:"h1"}}),d=new X({props:{title:"SyncRefModelCallback",local:"trl.SyncRefModelCallback",headingTag:"h2"}}),y=new ae({props:{name:"class trl.SyncRefModelCallback",anchor:"trl.SyncRefModelCallback",parameters:[{name:"ref_model",val:": Union"},{name:"accelerator",val:": Optional"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/callbacks.py#L86"}}),M=new X({props:{title:"RichProgressCallback",local:"trl.RichProgressCallback",headingTag:"h2"}}),W=new ae({props:{name:"class trl.RichProgressCallback",anchor:"trl.RichProgressCallback",parameters:[],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/callbacks.py#L121"}}),P=new X({props:{title:"WinRateCallback",local:"trl.WinRateCallback",headingTag:"h2"}}),j=new ae({props:{name:"class trl.WinRateCallback",anchor:"trl.WinRateCallback",parameters:[{name:"judge",val:": BasePairwiseJudge"},{name:"trainer",val:": Trainer"},{name:"generation_config",val:": Optional = None"},{name:"num_prompts",val:": int = None"}],parametersDescription:[{anchor:"trl.WinRateCallback.judge",description:`<strong>judge</strong> (<code>BasePairwiseJudge</code>) &#x2014;
The judge to use for comparing completions.`,name:"judge"},{anchor:"trl.WinRateCallback.trainer",description:`<strong>trainer</strong> (<code>Trainer</code>) &#x2014;
Trainer to which the callback will be attached. The trainer&#x2019;s evaluation dataset must include a <code>&quot;prompt&quot;</code>
column containing the prompts for generating completions. If the <code>Trainer</code> has a reference model (via the
<code>ref_model</code> attribute), it will use this reference model for generating the reference completions;
otherwise, it defaults to using the initial model.`,name:"trainer"},{anchor:"trl.WinRateCallback.generation_config",description:`<strong>generation_config</strong> (<code>GenerationConfig</code>, <em>optional</em>) &#x2014;
The generation config to use for generating completions.`,name:"generation_config"},{anchor:"trl.WinRateCallback.num_prompts",description:`<strong>num_prompts</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The number of prompts to generate completions for. If not provided, defaults to the number of examples
in the evaluation dataset.`,name:"num_prompts"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/callbacks.py#L198"}}),v=new fe({props:{anchor:"trl.WinRateCallback.example",$$slots:{default:[ue]},$$scope:{ctx:H}}}),E=new ge({props:{source:"https://github.com/huggingface/trl/blob/main/docs/source/callbacks.mdx"}}),{c(){r=f("meta"),R=o(),p=f("p"),c=o(),g(m.$$.fragment),n=o(),g(d.$$.fragment),V=o(),x=f("div"),g(y.$$.fragment),D=o(),g(M.$$.fragment),G=o(),C=f("div"),g(W.$$.fragment),Q=o(),J=f("p"),J.innerHTML=ne,Y=o(),g(P.$$.fragment),Z=o(),s=f("div"),g(j.$$.fragment),z=o(),U=f("p"),U.innerHTML=re,ee=o(),L=f("p"),L.innerHTML=le,te=o(),g(v.$$.fragment),q=o(),g(E.$$.fragment),B=o(),S=f("p"),this.h()},l(e){const t=de("svelte-u9bgzb",document.head);r=u(t,"META",{name:!0,content:!0}),t.forEach(a),R=i(e),p=u(e,"P",{}),N(p).forEach(a),c=i(e),h(m.$$.fragment,e),n=i(e),h(d.$$.fragment,e),V=i(e),x=u(e,"DIV",{class:!0});var I=N(x);h(y.$$.fragment,I),I.forEach(a),D=i(e),h(M.$$.fragment,e),G=i(e),C=u(e,"DIV",{class:!0});var O=N(C);h(W.$$.fragment,O),Q=i(O),J=u(O,"P",{"data-svelte-h":!0}),K(J)!=="svelte-4ypj8u"&&(J.innerHTML=ne),O.forEach(a),Y=i(e),h(P.$$.fragment,e),Z=i(e),s=u(e,"DIV",{class:!0});var w=N(s);h(j.$$.fragment,w),z=i(w),U=u(w,"P",{"data-svelte-h":!0}),K(U)!=="svelte-16rvof"&&(U.innerHTML=re),ee=i(w),L=u(w,"P",{"data-svelte-h":!0}),K(L)!=="svelte-bpyf2p"&&(L.innerHTML=le),te=i(w),h(v.$$.fragment,w),w.forEach(a),q=i(e),h(E.$$.fragment,e),B=i(e),S=u(e,"P",{}),N(S).forEach(a),this.h()},h(){F(r,"name","hf:doc:metadata"),F(r,"content",$e),F(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),F(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),F(s,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,t){T(document.head,r),l(e,R,t),l(e,p,t),l(e,c,t),$(m,e,t),l(e,n,t),$(d,e,t),l(e,V,t),l(e,x,t),$(y,x,null),l(e,D,t),$(M,e,t),l(e,G,t),l(e,C,t),$(W,C,null),T(C,Q),T(C,J),l(e,Y,t),$(P,e,t),l(e,Z,t),l(e,s,t),$(j,s,null),T(s,z),T(s,U),T(s,ee),T(s,L),T(s,te),$(v,s,null),l(e,q,t),$(E,e,t),l(e,B,t),l(e,S,t),A=!0},p(e,[t]){const I={};t&2&&(I.$$scope={dirty:t,ctx:e}),v.$set(I)},i(e){A||(b(m.$$.fragment,e),b(d.$$.fragment,e),b(y.$$.fragment,e),b(M.$$.fragment,e),b(W.$$.fragment,e),b(P.$$.fragment,e),b(j.$$.fragment,e),b(v.$$.fragment,e),b(E.$$.fragment,e),A=!0)},o(e){k(m.$$.fragment,e),k(d.$$.fragment,e),k(y.$$.fragment,e),k(M.$$.fragment,e),k(W.$$.fragment,e),k(P.$$.fragment,e),k(j.$$.fragment,e),k(v.$$.fragment,e),k(E.$$.fragment,e),A=!1},d(e){e&&(a(R),a(p),a(c),a(n),a(V),a(x),a(D),a(G),a(C),a(Y),a(Z),a(s),a(q),a(B),a(S)),a(r),_(m,e),_(d,e),_(y),_(M,e),_(W),_(P,e),_(j),_(v),_(E,e)}}}const $e='{"title":"Callbacks","local":"callbacks","sections":[{"title":"SyncRefModelCallback","local":"trl.SyncRefModelCallback","sections":[],"depth":2},{"title":"RichProgressCallback","local":"trl.RichProgressCallback","sections":[],"depth":2},{"title":"WinRateCallback","local":"trl.WinRateCallback","sections":[],"depth":2}],"depth":1}';function be(H){return ie(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Re extends ce{constructor(r){super(),me(this,r,be,he,oe,{})}}export{Re as component};
